package cn.com.qmth.examcloud.core.print.service.bean;

import java.util.List;
import java.util.stream.Collectors;

import org.springframework.beans.BeanUtils;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;

import com.google.common.collect.Lists;

import cn.com.qmth.examcloud.core.print.common.utils.JsonMapper;
import cn.com.qmth.examcloud.core.print.entity.ExamQuestionStructure;
import cn.com.qmth.examcloud.core.print.entity.ExamStructure;

/**
 * @author weiwenhai
 * @since  2018.10.30
 */
public class ExamStructureConvert {
	
	public static ExamStructure of(ExamStructureInfo info){
		ExamStructure entity = new ExamStructure();
		BeanUtils.copyProperties(info, entity);
		String struct = new JsonMapper().toJson(info.getExamQuestionStructures());
		entity.setStruct(struct);
		return entity;
	}
	
	public static ExamStructureInfo of(ExamStructure entity){
		ExamStructureInfo info = new ExamStructureInfo();
		BeanUtils.copyProperties(entity, info);
		List<ExamQuestionStructure> list = new JsonMapper().toList(entity.getStruct(), ExamQuestionStructure.class);
		info.setExamQuestionStructures(list);
		return info;
	}

	public static Page<ExamStructureInfo> ofPage(Page<ExamStructure> page){
		Pageable pageable = new PageRequest(page.getNumber(), page.getSize());
		List<ExamStructure> entities = page.getContent();
		if(entities == null || entities.isEmpty()){
			return new PageImpl<ExamStructureInfo>(Lists.newArrayList(), pageable, page.getTotalElements());
		}
		List<ExamStructureInfo> list = entities.stream().map(entity -> of(entity)).collect(Collectors.toList());
		return new PageImpl<ExamStructureInfo>(list, pageable ,page.getTotalElements());
	}
}
